#ifndef __SCANCONV_H__
#define __SCANCONV_H__
#ifdef __cplusplus
extern "C" {
#endif

/*
 * scanconv.h
 *
 *     Converting between image data types, a row at a time
 *
 * Copyright 1992, Silicon Graphics, Inc.
 * All Rights Reserved.
 *
 * This is UNPUBLISHED PROPRIETARY SOURCE CODE of Silicon Graphics,
 * Inc.; the contents of this file may not be disclosed to third
 * parties, copied or duplicated in any form, in whole or in part,
 * without the prior written permission of Silicon Graphics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND:
 * Use, duplication or disclosure by the Government is subject to
 * restrictions as set forth in subdivision (c)(1)(ii) of the Rights
 * in Technical Data and Computer Software clause at DFARS
 * 252.227-7013, and/or in similar or successor clauses in the FAR,
 * DOD or NASA FAR Supplement. Unpublished - rights reserved under the
 * Copyright Laws of the United States.
 */

#ident "$Revision: 1.10 $"

/*
 * Units
 */

#define CMPERINCH (2.54)

#define INCHTOCM(inch) ((inch) * CMPERINCH)
#define CMTOINCH(cm) ((cm) / CMPERINCH)

/*
 * Zooming
 */
#define GRIDTOFLOAT(pos,n)	(((pos)+0.5)/(n))
#define FLOATTOGRID(pos,n)	((pos)*(n))

#if defined(_LANGUAGE_C) || defined(_LANGUAGE_C_PLUS_PLUS)

int *SCCreateZoomMap(int anx, int bnx);
void SCDestroyZoomMap(int *zmap);
void SCZoomRow1(void *abuf, int anx, void *bbuf, int bnx, int *zmap);
void SCZoomRow3(void *abuf, int anx, void *bbuf, int bnx, int *zmap);
void SCZoomRow4(void *abuf, int anx, void *bbuf, int bnx, int *zmap);
void SCZoomRow8(void *abuf, int anx, void *bbuf, int bnx, int *zmap);
void SCZoomRow24(void *abuf, int anx, void *bbuf, int bnx, int *zmap);
void SCZoomRow32(void *abuf, int anx, void *bbuf, int bnx, int *zmap);

/*
 * Zooming and transforming at the same time
 */
void
SCBandRGB8ToPixelRGB8(void *frombuf, int fromx, void *tobuf, int tox,
		      int *zmap);

void
SCGrey8ToMono(unsigned char thresh, void *frombuf, int fromx,
	      void *tobuf, int tox, int *zmap);

void
SCBandRGB8ToMono(unsigned char thresh, void *from, int fromx,
		 void *to, int tox, int *zmap);

#endif /* C || C++ */

#ifdef __cplusplus
}
#endif
#endif /* !__SCANIPC_H__ */
